# -*- coding: utf-8 -*-
import os
import sys
from PySide import QtGui,QtCore
from FreeCAD import Base
import FreeCAD, Part , math
from math import pi
import FreeCAD as App
import FreeCADGui
from hdrl_data import ParamStraight
from hdrl_data import ParamEndLine
from hdrl_data import ParamCircular
from hdrl_data import HandData
        
class ViewProvider:
    def __init__(self, obj):
        obj.Proxy = self
        return

class Ui_Dialog(object):
    def setupUi(self, Dialog):
        Dialog.setObjectName("Dialog")
        Dialog.resize(260, 400)
        Dialog.move(1000, 0)
        #タイプ
        self.label_type = QtGui.QLabel(Dialog)
        self.label_type.setGeometry(QtCore.QRect(10, 15, 60, 12))
        self.label_type.setObjectName("label_type")
        self.comboBox_type = QtGui.QComboBox(Dialog)
        self.comboBox_type.setGeometry(QtCore.QRect(80, 15, 160, 22))
        self.comboBox_type.setObjectName("comboBox_type")
        #仕様
        self.label_siyo = QtGui.QLabel(Dialog)
        self.label_siyo.setGeometry(QtCore.QRect(10, 40, 60, 12))
        self.label_siyo.setObjectName("label_st")
        self.comboBox_siyo = QtGui.QComboBox(Dialog)
        self.comboBox_siyo.setGeometry(QtCore.QRect(80, 40, 160, 22))
        self.comboBox_siyo.setObjectName("comboBox_st")
        #長さL1
        self.label_l1 = QtGui.QLabel(Dialog)
        self.label_l1.setGeometry(QtCore.QRect(10, 92, 60, 12))
        self.label_l1.setObjectName("label_L1")
        self.lineEdit_l1 = QtGui.QLineEdit('L1',Dialog)
        self.lineEdit_l1.setGeometry(QtCore.QRect(80, 90, 50, 20))
        self.lineEdit_l1.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_l1.setObjectName("lineEdit_L1")
        #長さL2
        self.label_l2 = QtGui.QLabel(Dialog)
        self.label_l2.setGeometry(QtCore.QRect(133, 92, 60, 12))
        self.label_l2.setObjectName("label_L2")
        self.lineEdit_l2 = QtGui.QLineEdit('L2',Dialog)
        self.lineEdit_l2.setGeometry(QtCore.QRect(197, 90, 43, 20))
        self.lineEdit_l2.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_l2.setObjectName("lineEdit_L1")
        #コーナー角度
        self.label_cn = QtGui.QLabel(Dialog)
        self.label_cn.setGeometry(QtCore.QRect(133, 117, 60, 12))
        self.label_cn.setObjectName("label_cn")
        self.lineEdit_cn = QtGui.QLineEdit(Dialog)
        self.lineEdit_cn.setGeometry(QtCore.QRect(197, 115, 43, 20))
        self.lineEdit_cn.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_cn.setObjectName("lineEdit_cn")
        #実行
        self.pushButton = QtGui.QPushButton(Dialog)
        self.pushButton.setGeometry(QtCore.QRect(180, 140, 61, 22))
        self.pushButton.setObjectName("pushButton")
        #手すり高
        self.label_l = QtGui.QLabel(Dialog)
        self.label_l.setGeometry(QtCore.QRect(10, 117, 115, 20))
        self.label_l.setAlignment(QtCore.Qt.AlignLeft)
        self.label_l.setObjectName("label_l")
        self.lineEdit_l = QtGui.QLineEdit(Dialog)
        self.lineEdit_l.setGeometry(QtCore.QRect(80, 115, 50, 20))
        self.lineEdit_l.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_l.setObjectName("lineEdit_l")
        #img
        self.img = QtGui.QLabel(Dialog)
        self.img.setGeometry(QtCore.QRect(30, 180, 200, 200))
        self.img.setAlignment(QtCore.Qt.AlignCenter)
        self.retranslateUi(Dialog)
        self.comboBox_type.addItems(HandData.type)
        self.comboBox_siyo.addItems(HandData.siyo)
        self.comboBox_siyo.currentIndexChanged[int].connect(self.on_type)
        self.comboBox_type.currentIndexChanged[int].connect(self.on_type)
        self.lineEdit_l.setText(QtGui.QApplication.translate("Dialog", '1100', None))
        self.lineEdit_l1.setText(QtGui.QApplication.translate("Dialog", '1500', None))
        self.lineEdit_l2.setText(QtGui.QApplication.translate("Dialog", '1000', None))
        self.lineEdit_cn.setText(QtGui.QApplication.translate("Dialog", '90', None))
        self.comboBox_type.setCurrentIndex(1)
        self.comboBox_type.currentIndexChanged[int].connect(self.on_type)
        self.comboBox_type.setCurrentIndex(0)
        QtCore.QObject.connect(self.pushButton, QtCore.SIGNAL("pressed()"), self.create)
        QtCore.QMetaObject.connectSlotsByName(Dialog)

    def retranslateUi(self, Dialog):
        Dialog.setWindowTitle(QtGui.QApplication.translate("Dialog", "Handrail", None))
        self.label_type.setText(QtGui.QApplication.translate("Dialog", "Type", None))
        self.label_siyo.setText(QtGui.QApplication.translate("Dialog", "Spec", None))
        self.label_l1.setText(QtGui.QApplication.translate("Dialog", "length L1[m]", None))
        self.label_l2.setText(QtGui.QApplication.translate("Dialog", "length L2[m]", None))
        self.label_cn.setText(QtGui.QApplication.translate("Dialog", "angle k[deg]", None))
        self.label_l.setText(QtGui.QApplication.translate("Dialog", "height h[m]", None))
        self.pushButton.setText(QtGui.QApplication.translate("Dialog", "Create", None))

    def on_type(self):
        global key
        global spec_siyo
        
        key = self.comboBox_type.currentText()[:2]
        try:
            l=float(self.lineEdit_l.text())
            h=float(self.lineEdit_l.text())
            l1=float(self.lineEdit_l1.text())
            l2=float(self.lineEdit_l2.text())
            k=float(self.lineEdit_cn.text())
        except:
            pass

        spec_siyo=str(self.comboBox_siyo.currentIndex())
        if key=='00':
            pic=spec_siyo+'_手すり01L.jpg'
            self.label_l1.setText(QtGui.QApplication.translate("Dialog", "length l1[m]", None))
            self.label_l2.setText(QtGui.QApplication.translate("Dialog", "", None))
            self.label_cn.setText(QtGui.QApplication.translate("Dialog", "", None))
            self.lineEdit_l2.setText(QtGui.QApplication.translate("Dialog", "", None))
            self.lineEdit_cn.setText(QtGui.QApplication.translate("Dialog", "", None))
        elif key=='01':
            pic=spec_siyo+'_端部01L.jpg'
            self.label_l1.setText(QtGui.QApplication.translate("Dialog", "length l1[m]", None))
            self.label_l2.setText(QtGui.QApplication.translate("Dialog", "length l2[m]", None))
            self.label_cn.setText(QtGui.QApplication.translate("Dialog", "angle k[deg]", None))
            self.lineEdit_l2.setText(QtGui.QApplication.translate("Dialog", "1000", None))
            self.lineEdit_cn.setText(QtGui.QApplication.translate("Dialog", "90", None))
        elif key=='02':
            pic=spec_siyo+'_コーナー01L.jpg'
            self.label_l1.setText(QtGui.QApplication.translate("Dialog", "length l1[m]", None))
            self.label_l2.setText(QtGui.QApplication.translate("Dialog", "length l2[m]", None))
            self.label_cn.setText(QtGui.QApplication.translate("Dialog", "angle k[deg]", None))
            self.lineEdit_l2.setText(QtGui.QApplication.translate("Dialog", "1000", None))
            self.lineEdit_cn.setText(QtGui.QApplication.translate("Dialog", "90", None))
        elif key=='03':
            pic=spec_siyo+'_arc01.jpg'
            self.label_l1.setText(QtGui.QApplication.translate("Dialog", "radius R[m]", None))
            self.label_l2.setText(QtGui.QApplication.translate("Dialog", "", None))
            self.label_cn.setText(QtGui.QApplication.translate("Dialog", "angle k[deg]", None))
            self.lineEdit_l2.setText(QtGui.QApplication.translate("Dialog", "", None))
            self.lineEdit_cn.setText(QtGui.QApplication.translate("Dialog", "90", None))

        base=os.path.dirname(os.path.abspath(__file__))
        joined_path = os.path.join(base, "hdrl_data",pic)
        self.img.setPixmap(QtGui.QPixmap(joined_path))
    def create(self):
        global L0
        global l
        global h
        global l1
        global l2
        global k
        if key=='00':
            label='StraightLine'
        elif key=='01':
            label='Corner with end'
        elif key=='02':
            label='Corner' 
        elif key=='03':
            label='Circular_arc'     
        obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
        obj.addProperty("App::PropertyEnumeration", "spec",label)
        obj.spec=HandData.siyo
        i=self.comboBox_siyo.currentIndex()
        obj.spec=HandData.siyo[i] 

        h=float(self.lineEdit_l.text())
        l1=float(self.lineEdit_l1.text())
        if key=='03':
            pass
        else:
            l2=self.lineEdit_l2.text()
        k=self.lineEdit_cn.text()
        obj.addProperty("App::PropertyFloat", "h",label).h=h
        if key=='00' :
            obj.addProperty("App::PropertyFloat", "l1",label).l1=l1
            obj.addProperty("App::PropertyEnumeration", "type",label)
            obj.type=HandData.type[:1]
            i=self.comboBox_type.currentIndex()
            obj.type=HandData.type[i] 
            ParamStraight.StraightLine(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 
        elif key=='01' or key=='02' :    
            obj.addProperty("App::PropertyFloat", "l1",label).l1=l1
            obj.addProperty("App::PropertyFloat", "l2",label).l2=float(l2)
            obj.addProperty("App::PropertyFloat", "k",label).k=float(k)
            obj.addProperty("App::PropertyEnumeration", "type",label)
            obj.type=HandData.type[1:3]
            i=self.comboBox_type.currentIndex()
            obj.type=HandData.type[i] 
            ParamEndLine.EndLine(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 
        elif key=='03':
            obj.addProperty("App::PropertyFloat", "R",label).R=l1
            obj.addProperty("App::PropertyFloat", "k",label).k=float(k)
            obj.addProperty("App::PropertyEnumeration", "type",label)
            obj.type=HandData.type[3:]
            i=self.comboBox_type.currentIndex()
            obj.type=HandData.type[i] 
            ParamCircular.circular_arc(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute()     

class Main():
        d = QtGui.QWidget()
        d.ui = Ui_Dialog()
        d.ui.setupUi(d)
        d.show()





